
function openBluetoothAdapter(){
// 打开蓝牙
cloudhub.bluetooth.openBluetoothAdapter(function (res) {
    log(res)
})
}

function closeBluetoothAdapter(){
//关闭蓝牙适配器
cloudhub.bluetooth.closeBluetoothAdapter({

},function (res) {
    log(res)
})
}

function getBluetoothAdapterState(){
//获取本机蓝牙适配器状态
cloudhub.bluetooth.getBluetoothAdapterState({

},function (res) {
    log(res)
})
}

function startBluetoothDevicesDiscovery(){
//开始搜寻附近的蓝牙外围设备
cloudhub.bluetooth.startBluetoothDevicesDiscovery({
"services":['DC:1D:30:00:10:6A']
},function (res) {
    log(res)
})
}

function stopBluetoothDevicesDiscovery(){
//停止搜寻附近的蓝牙外围设备
cloudhub.bluetooth.stopBluetoothDevicesDiscovery({

},function (res) {
    log(res)
})
}

function getBluetoothDevices(){
//获取所有已发现的蓝牙设备
cloudhub.bluetooth.getBluetoothDevices({

},function (res) {
    log(res)
})
}

function getConnectedBluetoothDevices(){
//根据 uuid 获取处于已连接状态的设备
cloudhub.bluetooth.getConnectedBluetoothDevices({
    "services":["08:D4:0C:B1:9B:7A"]
},function (res) {
    log(res)
})
}

function createBLEConnection(){
//连接低功耗蓝牙设备
cloudhub.bluetooth.createBLEConnection({
    "deviceId":"DC:1D:30:00:10:6A",
    "serviceId":"0000fee7-0000-1000-8000-00805f9b34fb",
    "characteristicId":"0000fec7-0000-1000-8000-00805f9b34fb",

},function (res) {
    log(res)
})
}

function closeBLEConnection(){
//断开与低功耗蓝牙设备的连接
cloudhub.bluetooth.closeBLEConnection({
    "deviceId":"08:D4:0C:B1:9B:7A",
},function (res) {
    log(res)
})
}

function getBLEDeviceServices(){
//获取蓝牙设备所有 service（服务）
cloudhub.bluetooth.getBLEDeviceServices({
    "deviceId":"DC:1D:30:00:10:6A",
},function (res) {
    log(res)
})
}

function getBLEDeviceCharacteristics(){
//获取蓝牙设备所有 characteristic（特征值）
cloudhub.bluetooth.getBLEDeviceCharacteristics({
    "deviceId":"DC:1D:30:00:10:6A",
    "serviceId":"0000fee7-0000-1000-8000-00805f9b34fb",
},function (res) {
    log(res)
})
}
function readBLECharacteristicValue(){
//读取低功耗蓝牙设备的特征值的二进制数据值
cloudhub.bluetooth.readBLECharacteristicValue({
    "deviceId":"DC:1D:30:00:10:6A",
    "serviceId":"0000fee7-0000-1000-8000-00805f9b34fb",
    "characteristicId":"bef8d6c9-9c21-4c9e-b632-bd58c1009f9f",
},function (res) {
    log(res)
})
}
function writeBLECharacteristicValue(){
//向低功耗蓝牙设备特征值中写入二进制数据
cloudhub.bluetooth.writeBLECharacteristicValue({
    "deviceId":"DC:1D:30:00:10:6A",
    "serviceId":"0000fee7-0000-1000-8000-00805f9b34fb",
    "characteristicId":"0000fec7-0000-1000-8000-00805f9b34fb",
    "value":[27,97,1,29,33,17,-78,-30,-54,-44,-76,-14,-45,-95,10]
},function (res) {
    log(res)
})
}

function notifyBLECharacteristicValueChange(){
//启用低功耗蓝牙设备特征值变化时的 notify 功能
cloudhub.bluetooth.notifyBLECharacteristicValueChange({

},function (res) {
    log(res)
})
}

function onBluetoothAdapterStateChange(){
//蓝牙状态变更通知
cloudhub.bluetooth.onBluetoothAdapterStateChange({

},function (res) {
    log(res)
})
}

function onBluetoothDeviceFound(){
//蓝牙设备被找到回调
cloudhub.bluetooth.onBluetoothDeviceFound({

},function (res) {
    log(res)
})
}

function onBLEConnectionStateChange(){
//低功耗蓝牙连接状态
cloudhub.bluetooth.onBLEConnectionStateChange({

},function (res) {
    log(res)
})
}

function onBLECharacteristicValueChange(){
//低功耗蓝牙特征值改变通知
cloudhub.bluetooth.onBLECharacteristicValueChange({

},function (res) {
    log(res)
})
}

function onBluetoothConnectionStateChange(){
//蓝牙连接状态通知
cloudhub.bluetooth.onBluetoothConnectionStateChange({

},function (res) {
    log(res)
})
}

function BLEPrint(){
//向低功耗蓝牙设备特征值中写入二进制数据
cloudhub.bluetooth.BLEPrint({
    "deviceId":"DC:1D:30:00:10:6A",
    "serviceId":"0000fee7-0000-1000-8000-00805f9b34fb",
    "characteristicId":"0000fec7-0000-1000-8000-00805f9b34fb",
    "content":""
    +"测打印<BR>"
        + "<C><F>测试打印<BR></F></C>"
        + "名称　　　　　 单价  数量 金额<BR>"
        + "--------------------------------<BR>"
        + "饭　　　　　　 1.0    1   1.0<BR>"
        + "炒饭　　　　　 10.0   10  10.0<BR>"
        + "蛋炒饭　　　　 10.0   10  100.0<BR>"
        + "鸡蛋炒饭　　　 100.0  1   100.0<BR>"
        + "番茄蛋炒饭　　 1000.0 1   100.0<BR>"
        + "西红柿蛋炒饭　 1000.0 1   100.0<BR>"
        + "西红柿鸡蛋炒饭 100.0  10  100.0<BR>"
        + "备注：加辣<BR>"
        + "--------------------------------<BR>"
        + "<R>合计：xx.0元<BR></R>"
        + "送货地点：深圳市南山区xx路xx号<BR>"
        + "<B>联系电话：13888888888888</B><BR>"
        + "订餐时间：2016-08-08 08:08:08<BR>"
        + "<QR>http://www.yunzhijia.com</QR>"
        + "结束测试打印"
},function (res) {
    log(res)
})
}

//字符转换为UTF-8编码
function EncodeUtf8(s1)
{
      var s = escape(s1);
      var sa = s.split("%");
      var retV ="";
      if(sa[0] != "")
      {
         retV = sa[0];
      }
      for(var i = 1; i < sa.length; i ++)
      {
           if(sa[i].substring(0,1) == "u")
           {
               retV += Hex2Utf8(Str2Hex(sa[i].substring(1,5)));

           }
           else retV += "%" + sa[i];
      }

      return retV;
}
function Str2Hex(s)
{
      var c = "";
      var n;
      var ss = "0123456789ABCDEF";
      var digS = "";
      for(var i = 0; i < s.length; i ++)
      {
         c = s.charAt(i);
         n = ss.indexOf(c);
         digS += Dec2Dig(eval(n));

      }
      //return value;
      return digS;
}
function Dec2Dig(n1)
{
      var s = "";
      var n2 = 0;
      for(var i = 0; i < 4; i++)
      {
         n2 = Math.pow(2,3 - i);
         if(n1 >= n2)
         {
            s += '1';
            n1 = n1 - n2;
          }
         else
          s += '0';

      }
      return s;

}
function Dig2Dec(s)
{
      var retV = 0;
      if(s.length == 4)
      {
          for(var i = 0; i < 4; i ++)
          {
              retV += eval(s.charAt(i)) * Math.pow(2, 3 - i);
          }
          return retV;
      }
      return -1;
}
function Hex2Utf8(s)
{
     var retS = "";
     var tempS = "";
     var ss = "";
     if(s.length == 16)
     {
         tempS = "1110" + s.substring(0, 4);
         tempS += "10" + s.substring(4, 10);
         tempS += "10" + s.substring(10,16);
         var sss = "0123456789ABCDEF";
         for(var i = 0; i < 3; i ++)
         {
            retS += "%";
            ss = tempS.substring(i * 8, (eval(i)+1)*8);



            retS += sss.charAt(Dig2Dec(ss.substring(0,4)));
            retS += sss.charAt(Dig2Dec(ss.substring(4,8)));
         }
         return retS;
     }
     return "";
}